from enum import Enum
import math
from faker import Faker
from fastapi import Body, FastAPI, Request, Response
from fastapi.middleware.cors import CORSMiddleware
from pydantic import BaseModel


from settings import settings

app = FastAPI(
    title="Booking Engine",
    version="0.1.0",
)

app.add_middleware(CORSMiddleware, allow_origins=["*"], allow_methods=["*"])


@app.get("/")
async def hello():
    return "Hello world."


fake = Faker()


class BookingPayload(BaseModel):
    hotel: str | None = None
    car: str | None = None


@app.post("/book")
async def book_hotel_and_or_car(payload: BookingPayload):
    return_dict = {}
    if payload.hotel:
        return_dict["hotel"] = book_hotel(payload.hotel)

    if payload.car:
        return_dict["car"] = book_car(payload.car)

    return return_dict


def book_hotel(hotel: str):
    math.factorial(settings.speed.factorial)

    take_payment()

    confirmation_number = fake.bothify(text="????-########").upper()

    return {"status": "success", "name": hotel, "code": confirmation_number}


def book_car(car: str):
    math.factorial(settings.speed.factorial)

    take_payment()

    confirmation_number = fake.uuid4().replace("-", "")[:13].upper()

    return {"status": "success", "name": car, "code": confirmation_number}


def take_payment():
    math.factorial(settings.speed.factorial)
